#include <stdio.h>

unsigned char cartridge[128*1024];
unsigned char tape[96*1024+1];

void usage()
{
	fprintf(stderr,"Usage: buildcart [name].\n\n");
	fprintf(stderr,"Construit une cartouche Super-Oric 128 Ko a partir d'oric2.sys.\n");
	fprintf(stderr,"Si un nom est fourni en argument, une extension .tap est ajoutee pour\n");
	fprintf(stderr,"chercher une image de cassette a inclure, et une cartouche de meme nom\n");
	fprintf(stderr,"et d'extension .smc est fabriquee.\n");
	fprintf(stderr,"Si aucun argument n'est fourni, la cartouche est appelee oric2.smc\n\n");
	exit(1);
}
int main(int argc, char *argv[])
{
	FILE *syst, *cart;
	char cart_file[128]="oric2.smc";
	int size,i;

	if (argc>2) usage();

	syst=fopen("oric2.sys","rb");
	if (syst==NULL) usage();
	size=fread(cartridge,1,32768+1,syst);
	if (size!=32768) usage();
	fclose(syst);
	for (i=32768;i<128*1024;i++) cartridge[i]=0xFF;

	if (argc==2) {
		char tapefile[128];
		int start;
		FILE *fd;
		sprintf(tapefile,"%s.tap",argv[1]);
		fd=fopen(tapefile,"rb");
		if (fd==NULL) usage();
		size=fread(tape,1,96*1024+1,fd);
		fclose(fd);
		if (size>96*1024) {
			fprintf(stderr,"Fichier .tap trop gros\n");
			exit(1);
		}
		start=128*1024-size;
		for (i=0;i<size;i++) cartridge[start+i]=tape[i];
		sprintf(cart_file,"%s.smc",argv[1]);
	}

	cart=fopen(cart_file,"wb");
	if (cart==NULL) {
		fprintf(stderr,"Impossible d'ecrire la cartouche\n");
		exit(1);
	}
	size=fwrite(cartridge,1,128*1024,cart);
	if (size<128*1024) {
		fprintf(stderr,"Impossible d'ecrire la cartouche\n");
		exit(1);
	}
	fclose(cart);
	printf("Fichier %s ecrit avec succes.\n",cart_file);
}
